| CMSIS-DSP Verison 1.1.0 CMSIS DSP Software Library

- CMSIS
- CORE
- DSP
- RTOS API
- SVD

- Main Page
- Reference

Functions
Finite Impulse Response (FIR) Lattice Filters
Filtering Functions

## Functions
void | arm_fir_lattice_f32 (const arm_fir_lattice_instance_f32 *S, float32_t *pSrc, float32_t *pDst, uint32_t blockSize)
| Processing function for the floating-point FIR lattice filter.
void | arm_fir_lattice_init_f32 (arm_fir_lattice_instance_f32 *S, uint16_t numStages, float32_t *pCoeffs, float32_t *pState)
| Initialization function for the floating-point FIR lattice filter.
void | arm_fir_lattice_init_q15 (arm_fir_lattice_instance_q15 *S, uint16_t numStages, q15_t *pCoeffs, q15_t *pState)
| Initialization function for the Q15 FIR lattice filter.
void | arm_fir_lattice_init_q31 (arm_fir_lattice_instance_q31 *S, uint16_t numStages, q31_t *pCoeffs, q31_t *pState)
| Initialization function for the Q31 FIR lattice filter.
void | arm_fir_lattice_q15 (const arm_fir_lattice_instance_q15 *S, q15_t *pSrc, q15_t *pDst, uint32_t blockSize)
| Processing function for the Q15 FIR lattice filter.
void | arm_fir_lattice_q31 (const arm_fir_lattice_instance_q31 *S, q31_t *pSrc, q31_t *pDst, uint32_t blockSize)
| Processing function for the Q31 FIR lattice filter.

## Description

This set of functions implements Finite Impulse Response (FIR) lattice filters for Q15, Q31 and floating-point data types. Lattice filters are used in a variety of adaptive filter applications. The filter structure is feedforward and the net impulse response is finite length. The functions operate on blocks of input and output data and each call to the function processes `blockSize` samples through the filter. `pSrc` and `pDst` point to input and output arrays containing `blockSize` values.

Algorithm:
  Finite Impulse Response Lattice filter
  The following difference equation is implemented:

          f0[n] = g0[n] = x[n]
          fm[n] = fm-1[n] + km * gm-1[n-1] for m = 1, 2, ...M
          gm[n] = km * fm-1[n] + gm-1[n-1] for m = 1, 2, ...M
          y[n] = fM[n]

  `pCoeffs` points to tha array of reflection coefficients of size `numStages`. Reflection Coefficients are stored in the following order.

          {k1, k2, ..., kM}

  where M is number of stages

  `pState` points to a state array of size `numStages`. The state variables (g values) hold previous inputs and are stored in the following order.

          {g0[n], g1[n], g2[n] ...gM-1[n]}

  The state variables are updated after each block of data is processed; the coefficients are untouched.

Instance Structure
  The coefficients and state variables for a filter are stored together in an instance data structure. A separate instance structure must be defined for each filter. Coefficient arrays may be shared among several instances while state variable arrays cannot be shared. There are separate instance structure declarations for each of the 3 supported data types.

Initialization Functions
  There is also an associated initialization function for each data type. The initialization function performs the following operations:
  - Sets the values of the internal structure fields.
  - Zeros out the values in the state buffer.

  Use of the initialization function is optional. However, if the initialization function is used, then the instance structure cannot be placed into a const data section. To place an instance structure into a const data section, the instance structure must be manually initialized. Set the values in the state buffer to zeros and then manually initialize the instance structure as follows:

      arm_fir_lattice_instance_f32 S = {numStages, pState, pCoeffs};
      arm_fir_lattice_instance_q31 S = {numStages, pState, pCoeffs};
      arm_fir_lattice_instance_q15 S = {numStages, pState, pCoeffs};

  where `numStages` is the number of stages in the filter; `pState` is the address of the state buffer; `pCoeffs` is the address of the coefficient buffer.

Fixed-Point Behavior
  Care must be taken when using the fixed-point versions of the FIR Lattice filter functions. In particular, the overflow and saturation behavior of the accumulator used in each function must be considered. Refer to the function specific documentation below for usage guidelines.

## Function Documentation

void arm_fir_lattice_f32 | ( | const arm_fir_lattice_instance_f32 * | S,
|  | float32_t * | pSrc,
|  | float32_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters:

  [in] | *S | points to an instance of the floating-point FIR lattice structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data
  [in] | blockSize | number of samples to process.

Returns:
  none.

References blockSize, arm_fir_lattice_instance_f32::numStages, arm_fir_lattice_instance_f32::pCoeffs, and arm_fir_lattice_instance_f32::pState.

void arm_fir_lattice_init_f32 | ( | arm_fir_lattice_instance_f32 * | S,
|  | uint16_t | numStages,
|  | float32_t * | pCoeffs,
|  | float32_t * | pState
| ) |  |

Parameters:

  [in] | *S | points to an instance of the floating-point FIR lattice structure.
  [in] | numStages | number of filter stages.
  [in] | *pCoeffs | points to the coefficient buffer. The array is of length numStages.
  [in] | *pState | points to the state buffer. The array is of length numStages.

Returns:
  none.

References arm_fir_lattice_instance_f32::numStages, arm_fir_lattice_instance_f32::pCoeffs, and arm_fir_lattice_instance_f32::pState.

void arm_fir_lattice_init_q15 | ( | arm_fir_lattice_instance_q15 * | S,
|  | uint16_t | numStages,
|  | q15_t * | pCoeffs,
|  | q15_t * | pState
| ) |  |

Parameters:

  [in] | *S | points to an instance of the Q15 FIR lattice structure.
  [in] | numStages | number of filter stages.
  [in] | *pCoeffs | points to the coefficient buffer. The array is of length numStages.
  [in] | *pState | points to the state buffer. The array is of length numStages.

Returns:
  none.

References arm_fir_lattice_instance_q15::numStages, arm_fir_lattice_instance_q15::pCoeffs, and arm_fir_lattice_instance_q15::pState.

void arm_fir_lattice_init_q31 | ( | arm_fir_lattice_instance_q31 * | S,
|  | uint16_t | numStages,
|  | q31_t * | pCoeffs,
|  | q31_t * | pState
| ) |  |

Parameters:

  [in] | *S | points to an instance of the Q31 FIR lattice structure.
  [in] | numStages | number of filter stages.
  [in] | *pCoeffs | points to the coefficient buffer. The array is of length numStages.
  [in] | *pState | points to the state buffer. The array is of length numStages.

Returns:
  none.

References arm_fir_lattice_instance_q31::numStages, arm_fir_lattice_instance_q31::pCoeffs, and arm_fir_lattice_instance_q31::pState.

void arm_fir_lattice_q15 | ( | const arm_fir_lattice_instance_q15 * | S,
|  | q15_t * | pSrc,
|  | q15_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters:

  [in] | *S | points to an instance of the Q15 FIR lattice structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data
  [in] | blockSize | number of samples to process.

Returns:
  none.

References __SIMD32, blockSize, arm_fir_lattice_instance_q15::numStages, arm_fir_lattice_instance_q15::pCoeffs, and arm_fir_lattice_instance_q15::pState.

void arm_fir_lattice_q31 | ( | const arm_fir_lattice_instance_q31 * | S,
|  | q31_t * | pSrc,
|  | q31_t * | pDst,
|  | uint32_t | blockSize
| ) |  |

Parameters:

  [in] | *S | points to an instance of the Q31 FIR lattice structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data
  [in] | blockSize | number of samples to process.

Returns:
  none.

Scaling and Overflow Behavior: In order to avoid overflows the input signal must be scaled down by 2*log2(numStages) bits.

References arm_fir_lattice_instance_q31::numStages, arm_fir_lattice_instance_q31::pCoeffs, and arm_fir_lattice_instance_q31::pState.